/*******************************************************************************
 * Copyright (c) 2010 IGA Tosiki, NTT DATA BUSINESS BRAINS Corp.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    IGA Tosiki (NTT DATA BUSINESS BRAINS Corp.) - initial API and implementation
 *******************************************************************************/
/*
 * blanco Framework
 * Copyright (C) 2010 NTT DATA BUSINESS BRAINS CORPORATION
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 */
package blanco.xls;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;

/**
 * Excel ubN - Apache POI ̃Vvȃbp[NXłB
 * 
 * Excel ̃ubN킵܂B
 * 
 * @author NDBɉ
 */
public class BlancoXlsBook {
    private HSSFWorkbook fWorkbook;

    /**
     * VK Excel ubN̍쐬
     */
    public BlancoXlsBook() {
        fWorkbook = new HSSFWorkbook();
    }

    /**
     * [NubN[h܂B
     * 
     * @param inStream
     * @throws IOException
     */
    public void load(final InputStream inStream) throws IOException {
        fWorkbook = new HSSFWorkbook(inStream);
        inStream.close();
    }

    /**
     * [NubNۑ܂B
     * 
     * @param outStream
     * @throws IOException
     */
    public void save(final OutputStream outStream) throws IOException {
        fWorkbook.write(outStream);
    }

    /**
     * Iɕێ POI IuWFNg߂܂B
     * 
     * @return
     */
    public HSSFWorkbook getWorkbook() {
        return fWorkbook;
    }

    /**
     * V[g쐬܂B
     * 
     * @param sheetName
     * @return
     */
    public BlancoXlsSheet createSheet(final String sheetName) {
        final HSSFSheet sheet = fWorkbook.createSheet(sheetName);

        return new BlancoXlsSheet(sheet);
    }

    /**
     * w̖ÕV[g擾܂B
     * 
     * @param sheetName
     * @return
     */
    public BlancoXlsSheet getSheet(final String sheetName) {
        final HSSFSheet sheet = fWorkbook.getSheet(sheetName);
        if (sheet == null) {
            throw new IllegalArgumentException("YV[g[" + sheetName
                    + "]݂͑܂B");
        }

        return new BlancoXlsSheet(sheet);
    }

    /**
     * w̃CfBbNX̃V[g擾܂B
     * 
     * @param sheetIndex
     * @return
     */
    public BlancoXlsSheet getSheetAt(final int sheetIndex) {
        final HSSFSheet sheet = fWorkbook.getSheetAt(sheetIndex);
        if (sheet == null) {
            throw new IllegalArgumentException("YV[g[" + sheetIndex
                    + "]݂͑܂B");
        }

        return new BlancoXlsSheet(sheet);
    }

    /**
     * ubNɊ܂܂V[g̐߂܂B
     * 
     * @return ubNɊ܂܂V[gB
     */
    public int getSheetCount() {
        return fWorkbook.getNumberOfSheets();
    }
}
